#include <stdio.h>
#include <stdlib.h>

#include "eva.h"
#define MaxN            1000
#define Inf             (MaxN * MaxN)

static long M[MaxN+1][MaxN+1];
static int F[MaxN+1][MaxN+1];
static int Pt[MaxN+1];
static int N;

static void Elofeldolg()
{
  int i, j, u, k, minu;
  long Mij, Miju;

  for (j = 1; j <= N; j++) {
    M[j][j] = 0;
    F[j][j] = 0;
    Pt[j] = P(j);
  }

  for (j = 2; j <= N; j++) {
    for (i = j-1; i >= 1; i--) {
      Mij = Inf;
      for (u = i; u < j; u++) {
	if (M[i][u] > M[u+1][j])
	  Miju = (long)Pt[u] + M[i][u];
	else
	  Miju = (long)Pt[u] + M[u+1][j];
	if (Miju < Mij) {
	  Mij = Miju;
	  minu = u;
	}
      }  /*u*/
      M[i][j] = Mij;
      F[i][j] = minu;
    }  /*i*/
  }  /*j*/
}  /*Elofeldolg*/

int main()
{
  int bal = 1;
  int jobb, koz;
  long kolt = 0;

  N = GetN(); 
  Elofeldolg();
  jobb = N;
  while (bal < jobb) {
//printf("%d %d \n",bal,jobb);        
    koz = F[bal][jobb];
    kolt += Pt[koz];
    if (Kerdes(koz) == 1)
      jobb = koz;
    else
      bal = koz + 1;
  }

  Megoldas(bal);
  exit(0);
}

