#include <stdio.h>
#include <stdlib.h>
#include "eva.h"

#define MaxN            1000
#define Inf             (MaxN * MaxN)
#define true 1
#define false 0

static int _N;
static int _Pt[MaxN+1];
static long _M[MaxN+1][MaxN+1];
static int _bal, _jobb;
static long _kolt;
static int _Init=true;
static long _X=1293735277L;
static long _XX;

static void _Vege(int ki)
{
  FILE *KiF = NULL;
  KiF = fopen("adam.ki", "w");
  fprintf(KiF, "%d\n", ki);
  fprintf(KiF, "%ld %ld\n", _kolt, _M[1][_N]);
  if (_X==_XX)
    fprintf(KiF, "%ld\n", _X);
  
  fclose(KiF);
  KiF = NULL;
  exit(0);
}  /*Vege*/

static void _Elofel()
{
  long i, j, k, u, Mij, Miju;

  for (j = 1; j <= _N; j++)
    _M[j][j] = 0;
 
  for (j = 2; j <= _N; j++) {
    for (i = j-1; i >= 1; i--) {
      Mij = Inf;
      for (u = i; u < j; u++) {
	if (_M[i][u] > _M[u+1][j])
	  Miju = (long)_Pt[u] + _M[i][u];
	else
	  Miju = (long)_Pt[u] + _M[u+1][j];
	if (Miju < Mij)
	  Mij = Miju;
      }  /*u*/
      _M[i][j] = Mij;
    }  /*i*/
  }  /*j*/
}  /*Elofel*/

static void _BeolVas()
{
  FILE *BeF = NULL;
  int x, y;
  int err;
  
  BeF = fopen("eva.be","r");
  fscanf(BeF, "%d%*[^\n]", &_N);
  getc(BeF);

  for (x = 1; x <= _N; x++) {
    fscanf(BeF, "%d", &y);
    _Pt[x] = y;
  }
  fscanf(BeF, "%*[^\n]"); 
  _XX=0L; 
  err=fscanf(BeF, "%ld", &_XX);
  
  if (BeF != NULL)
    fclose(BeF);
  BeF = NULL;
}  /*BeolVas*/

int GetN()
{
  if (_Init){
    _BeolVas();
    _bal = 1;
    _jobb = _N;
    _kolt = 0;
    _Elofel();
    _Init=false;
  }
  return _N;
}  /*GetN*/

int P(int x)
{
  if (_Init){
    printf("Elbb GetN kell!\n");
    _Vege(-1);
  }
  if (x < 1 || x > _N){
    printf("Hibs argumentum!\n");       
    _Vege(-1);
  }
  return (_Pt[x]);
}  /*P*/

int Kerdes(int x)
{
  if (_Init){
    printf("Elbb GetN kell!\n");
    _Vege(-1);
  }    
  if (x < 1 || x > _N){
    printf("Hibs argumentum!\n");               
    _Vege(-1);
}
  _kolt += _Pt[x];
  if (x < _bal)
    return 0;
  if (x >= _jobb)
    return 1;
  /*_bal<=x<_jobb*/
  if (_M[_bal][x] < _M[x+1][_jobb]) {
    _bal = x+1;
    return 0;
  } else {
    _jobb = x;
    return 1;
  }
}  /*Kerdes*/

void Megoldas(int x)
{
   if (_Init){
    printf("Elbb GetN kell!\n");
    _Vege(-1);
  }
  if (_bal < _jobb || x != _bal) {
    printf("Hibs argumentum!\n");                  
    _Vege(-1);
    return;
  }
  if (_kolt <= _M[1][_N])
    _Vege(_bal);
  else
    _Vege(0);
}  /*Megoldas*/
